// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <brep/types-parsers>
//
// End prologue.

#include <brep/options>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>
#include <cstring>
#include <fstream>

namespace brep
{
  namespace cli
  {
    // unknown_option
    //
    unknown_option::
    ~unknown_option () throw ()
    {
    }

    void unknown_option::
    print (::std::ostream& os) const
    {
      os << "unknown option '" << option ().c_str () << "'";
    }

    const char* unknown_option::
    what () const throw ()
    {
      return "unknown option";
    }

    // unknown_argument
    //
    unknown_argument::
    ~unknown_argument () throw ()
    {
    }

    void unknown_argument::
    print (::std::ostream& os) const
    {
      os << "unknown argument '" << argument ().c_str () << "'";
    }

    const char* unknown_argument::
    what () const throw ()
    {
      return "unknown argument";
    }

    // missing_value
    //
    missing_value::
    ~missing_value () throw ()
    {
    }

    void missing_value::
    print (::std::ostream& os) const
    {
      os << "missing value for option '" << option ().c_str () << "'";
    }

    const char* missing_value::
    what () const throw ()
    {
      return "missing option value";
    }

    // invalid_value
    //
    invalid_value::
    ~invalid_value () throw ()
    {
    }

    void invalid_value::
    print (::std::ostream& os) const
    {
      os << "invalid value '" << value ().c_str () << "' for option '"
         << option ().c_str () << "'";
    }

    const char* invalid_value::
    what () const throw ()
    {
      return "invalid option value";
    }

    // eos_reached
    //
    void eos_reached::
    print (::std::ostream& os) const
    {
      os << what ();
    }

    const char* eos_reached::
    what () const throw ()
    {
      return "end of argument stream reached";
    }

    // file_io_failure
    //
    file_io_failure::
    ~file_io_failure () throw ()
    {
    }

    void file_io_failure::
    print (::std::ostream& os) const
    {
      os << "unable to open file '" << file ().c_str () << "' or read failure";
    }

    const char* file_io_failure::
    what () const throw ()
    {
      return "unable to open file or read failure";
    }

    // unmatched_quote
    //
    unmatched_quote::
    ~unmatched_quote () throw ()
    {
    }

    void unmatched_quote::
    print (::std::ostream& os) const
    {
      os << "unmatched quote in argument '" << argument ().c_str () << "'";
    }

    const char* unmatched_quote::
    what () const throw ()
    {
      return "unmatched quote";
    }

    // scanner
    //
    scanner::
    ~scanner ()
    {
    }

    // argv_scanner
    //
    bool argv_scanner::
    more ()
    {
      return i_ < argc_;
    }

    const char* argv_scanner::
    peek ()
    {
      if (i_ < argc_)
        return argv_[i_];
      else
        throw eos_reached ();
    }

    const char* argv_scanner::
    next ()
    {
      if (i_ < argc_)
      {
        const char* r (argv_[i_]);

        if (erase_)
        {
          for (int i (i_ + 1); i < argc_; ++i)
            argv_[i - 1] = argv_[i];

          --argc_;
          argv_[argc_] = 0;
        }
        else
          ++i_;

        return r;
      }
      else
        throw eos_reached ();
    }

    void argv_scanner::
    skip ()
    {
      if (i_ < argc_)
        ++i_;
      else
        throw eos_reached ();
    }

    // argv_file_scanner
    //
    bool argv_file_scanner::
    more ()
    {
      if (!args_.empty ())
        return true;

      while (base::more ())
      {
        // See if the next argument is the file option.
        //
        const char* a (base::peek ());
        const option_info* oi;

        if (!skip_ && (oi = find (a)))
        {
          base::next ();

          if (!base::more ())
            throw missing_value (oi->option);

          if (oi->search_func != 0)
          {
            std::string f (oi->search_func (base::next (), oi->arg));

            if (!f.empty ())
              load (f);
          }
          else
            load (base::next ());

          if (!args_.empty ())
            return true;
        }
        else
        {
          if (!skip_)
            skip_ = (std::strcmp (a, "--") == 0);

          return true;
        }
      }

      return false;
    }

    const char* argv_file_scanner::
    peek ()
    {
      if (!more ())
        throw eos_reached ();

      return args_.empty () ? base::peek () : args_.front ().c_str ();
    }

    const char* argv_file_scanner::
    next ()
    {
      if (!more ())
        throw eos_reached ();

      if (args_.empty ())
        return base::next ();
      else
      {
        hold_.swap (args_.front ());
        args_.pop_front ();
        return hold_.c_str ();
      }
    }

    void argv_file_scanner::
    skip ()
    {
      if (!more ())
        throw eos_reached ();

      if (args_.empty ())
        return base::skip ();
      else
        args_.pop_front ();
    }

    const argv_file_scanner::option_info* argv_file_scanner::
    find (const char* a) const
    {
      for (std::size_t i (0); i < options_count_; ++i)
        if (std::strcmp (a, options_[i].option) == 0)
          return &options_[i];

      return 0;
    }

    void argv_file_scanner::
    load (const std::string& file)
    {
      using namespace std;

      ifstream is (file.c_str ());

      if (!is.is_open ())
        throw file_io_failure (file);

      while (!is.eof ())
      {
        string line;
        getline (is, line);

        if (is.fail () && !is.eof ())
          throw file_io_failure (file);

        string::size_type n (line.size ());

        // Trim the line from leading and trailing whitespaces.
        //
        if (n != 0)
        {
          const char* f (line.c_str ());
          const char* l (f + n);

          const char* of (f);
          while (f < l && (*f == ' ' || *f == '\t' || *f == '\r'))
            ++f;

          --l;

          const char* ol (l);
          while (l > f && (*l == ' ' || *l == '\t' || *l == '\r'))
            --l;

          if (f != of || l != ol)
            line = f <= l ? string (f, l - f + 1) : string ();
        }

        // Ignore empty lines, those that start with #.
        //
        if (line.empty () || line[0] == '#')
          continue;

        string::size_type p (line.find (' '));

        if (p == string::npos)
        {
          if (!skip_)
            skip_ = (line == "--");

          args_.push_back (line);
        }
        else
        {
          string s1 (line, 0, p);

          // Skip leading whitespaces in the argument.
          //
          n = line.size ();
          for (++p; p < n; ++p)
          {
            char c (line[p]);

            if (c != ' ' && c != '\t' && c != '\r')
              break;
          }

          string s2 (line, p);

          // If the string is wrapped in quotes, remove them.
          //
          n = s2.size ();
          char cf (s2[0]), cl (s2[n - 1]);

          if (cf == '"' || cf == '\'' || cl == '"' || cl == '\'')
          {
            if (n == 1 || cf != cl)
              throw unmatched_quote (s2);

            s2 = string (s2, 1, n - 2);
          }

          const option_info* oi;
          if (!skip_ && (oi = find (s1.c_str ())))
          {
            if (s2.empty ())
              throw missing_value (oi->option);

            if (oi->search_func != 0)
            {
              std::string f (oi->search_func (s2.c_str (), oi->arg));

              if (!f.empty ())
                load (f);
            }
            else
              load (s2);
          }
          else
          {
            args_.push_back (s1);
            args_.push_back (s2);
          }
        }
      }
    }

    void options::
    push_back (const option& o)
    {
      container_type::size_type n (size ());
      container_type::push_back (o);
      map_[o.name ()] = n;

      for (option_names::const_iterator i (o.aliases ().begin ());
           i != o.aliases ().end (); ++i)
        map_[*i] = n;
    }

    template <typename X>
    struct parser
    {
      static void
      parse (X& x, scanner& s)
      {
        std::string o (s.next ());

        if (s.more ())
        {
          std::string v (s.next ());
          std::istringstream is (v);
          if (!(is >> x && is.eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, scanner& s)
      {
        X x;
        parser<X>::parse (x, s);
        c.push_back (x);
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, scanner& s)
      {
        X x;
        parser<X>::parse (x, s);
        c.insert (x);
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] = 
          {
            const_cast<char*> (o), 0
          };

          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }
  }
}

#include <map>
#include <cstring>

namespace brep
{
  namespace options
  {
    // module
    //

    module::
    module ()
    : root_ ("/"),
      verbosity_ (0)
    {
    }

    module::
    module (int& argc,
            char** argv,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : root_ ("/"),
      verbosity_ (0)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    module::
    module (int start,
            int& argc,
            char** argv,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : root_ ("/"),
      verbosity_ (0)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    module::
    module (int& argc,
            char** argv,
            int& end,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : root_ ("/"),
      verbosity_ (0)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    module::
    module (int start,
            int& argc,
            char** argv,
            int& end,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : root_ ("/"),
      verbosity_ (0)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    module::
    module (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : root_ ("/"),
      verbosity_ (0)
    {
      _parse (s, opt, arg);
    }

    struct _cli_module_desc_type: ::brep::cli::options
    {
      _cli_module_desc_type ()
      {
        ::brep::options::module::fill (*this);
      }
    };

    void module::
    fill (::brep::cli::options& os)
    {
      // root
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("/");
        ::brep::cli::option o ("root", a, false, dv);
        os.push_back (o);
      }

      // verbosity
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("0");
        ::brep::cli::option o ("verbosity", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& module::
    description ()
    {
      static _cli_module_desc_type _cli_module_desc_;
      return _cli_module_desc_;
    };

    typedef
    std::map<std::string, void (*) (module&, ::brep::cli::scanner&)>
    _cli_module_map;

    static _cli_module_map _cli_module_map_;

    struct _cli_module_map_init
    {
      _cli_module_map_init ()
      {
        _cli_module_map_["root"] = 
        &::brep::cli::thunk< module, dir_path, &module::root_ >;
        _cli_module_map_["verbosity"] = 
        &::brep::cli::thunk< module, uint16_t, &module::verbosity_ >;
      }
    };

    static _cli_module_map_init _cli_module_map_init_;

    bool module::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_module_map::const_iterator i (_cli_module_map_.find (o));

      if (i != _cli_module_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void module::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // db
    //

    db::
    db ()
    : db_user_ (),
      db_password_ (),
      db_name_ ("brep"),
      db_host_ (),
      db_port_ (0)
    {
    }

    db::
    db (int& argc,
        char** argv,
        bool erase,
        ::brep::cli::unknown_mode opt,
        ::brep::cli::unknown_mode arg)
    : db_user_ (),
      db_password_ (),
      db_name_ ("brep"),
      db_host_ (),
      db_port_ (0)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    db::
    db (int start,
        int& argc,
        char** argv,
        bool erase,
        ::brep::cli::unknown_mode opt,
        ::brep::cli::unknown_mode arg)
    : db_user_ (),
      db_password_ (),
      db_name_ ("brep"),
      db_host_ (),
      db_port_ (0)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    db::
    db (int& argc,
        char** argv,
        int& end,
        bool erase,
        ::brep::cli::unknown_mode opt,
        ::brep::cli::unknown_mode arg)
    : db_user_ (),
      db_password_ (),
      db_name_ ("brep"),
      db_host_ (),
      db_port_ (0)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    db::
    db (int start,
        int& argc,
        char** argv,
        int& end,
        bool erase,
        ::brep::cli::unknown_mode opt,
        ::brep::cli::unknown_mode arg)
    : db_user_ (),
      db_password_ (),
      db_name_ ("brep"),
      db_host_ (),
      db_port_ (0)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    db::
    db (::brep::cli::scanner& s,
        ::brep::cli::unknown_mode opt,
        ::brep::cli::unknown_mode arg)
    : db_user_ (),
      db_password_ (),
      db_name_ ("brep"),
      db_host_ (),
      db_port_ (0)
    {
      _parse (s, opt, arg);
    }

    struct _cli_db_desc_type: ::brep::cli::options
    {
      _cli_db_desc_type ()
      {
        ::brep::options::db::fill (*this);
      }
    };

    void db::
    fill (::brep::cli::options& os)
    {
      // db-user
      //
      {
        ::brep::cli::option_names a;
        std::string dv;
        ::brep::cli::option o ("db-user", a, false, dv);
        os.push_back (o);
      }

      // db-password
      //
      {
        ::brep::cli::option_names a;
        std::string dv;
        ::brep::cli::option o ("db-password", a, false, dv);
        os.push_back (o);
      }

      // db-name
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("brep");
        ::brep::cli::option o ("db-name", a, false, dv);
        os.push_back (o);
      }

      // db-host
      //
      {
        ::brep::cli::option_names a;
        std::string dv;
        ::brep::cli::option o ("db-host", a, false, dv);
        os.push_back (o);
      }

      // db-port
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("0");
        ::brep::cli::option o ("db-port", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& db::
    description ()
    {
      static _cli_db_desc_type _cli_db_desc_;
      return _cli_db_desc_;
    };

    typedef
    std::map<std::string, void (*) (db&, ::brep::cli::scanner&)>
    _cli_db_map;

    static _cli_db_map _cli_db_map_;

    struct _cli_db_map_init
    {
      _cli_db_map_init ()
      {
        _cli_db_map_["db-user"] = 
        &::brep::cli::thunk< db, string, &db::db_user_ >;
        _cli_db_map_["db-password"] = 
        &::brep::cli::thunk< db, string, &db::db_password_ >;
        _cli_db_map_["db-name"] = 
        &::brep::cli::thunk< db, string, &db::db_name_ >;
        _cli_db_map_["db-host"] = 
        &::brep::cli::thunk< db, string, &db::db_host_ >;
        _cli_db_map_["db-port"] = 
        &::brep::cli::thunk< db, uint16_t, &db::db_port_ >;
      }
    };

    static _cli_db_map_init _cli_db_map_init_;

    bool db::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_db_map::const_iterator i (_cli_db_map_.find (o));

      if (i != _cli_db_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void db::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // search
    //

    search::
    search ()
    : search_results_ (10),
      search_pages_ (5)
    {
    }

    search::
    search (int& argc,
            char** argv,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : search_results_ (10),
      search_pages_ (5)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    search::
    search (int start,
            int& argc,
            char** argv,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : search_results_ (10),
      search_pages_ (5)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    search::
    search (int& argc,
            char** argv,
            int& end,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : search_results_ (10),
      search_pages_ (5)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    search::
    search (int start,
            int& argc,
            char** argv,
            int& end,
            bool erase,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : search_results_ (10),
      search_pages_ (5)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    search::
    search (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode opt,
            ::brep::cli::unknown_mode arg)
    : search_results_ (10),
      search_pages_ (5)
    {
      _parse (s, opt, arg);
    }

    struct _cli_search_desc_type: ::brep::cli::options
    {
      _cli_search_desc_type ()
      {
        ::brep::options::search::fill (*this);
      }
    };

    void search::
    fill (::brep::cli::options& os)
    {
      // search-results
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("10");
        ::brep::cli::option o ("search-results", a, false, dv);
        os.push_back (o);
      }

      // search-pages
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("5");
        ::brep::cli::option o ("search-pages", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& search::
    description ()
    {
      static _cli_search_desc_type _cli_search_desc_;
      return _cli_search_desc_;
    };

    typedef
    std::map<std::string, void (*) (search&, ::brep::cli::scanner&)>
    _cli_search_map;

    static _cli_search_map _cli_search_map_;

    struct _cli_search_map_init
    {
      _cli_search_map_init ()
      {
        _cli_search_map_["search-results"] = 
        &::brep::cli::thunk< search, uint16_t, &search::search_results_ >;
        _cli_search_map_["search-pages"] = 
        &::brep::cli::thunk< search, uint16_t, &search::search_pages_ >;
      }
    };

    static _cli_search_map_init _cli_search_map_init_;

    bool search::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_search_map::const_iterator i (_cli_search_map_.find (o));

      if (i != _cli_search_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void search::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // package
    //

    package::
    package ()
    : package_description_ (500),
      package_changes_ (5000)
    {
    }

    package::
    package (int& argc,
             char** argv,
             bool erase,
             ::brep::cli::unknown_mode opt,
             ::brep::cli::unknown_mode arg)
    : package_description_ (500),
      package_changes_ (5000)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package::
    package (int start,
             int& argc,
             char** argv,
             bool erase,
             ::brep::cli::unknown_mode opt,
             ::brep::cli::unknown_mode arg)
    : package_description_ (500),
      package_changes_ (5000)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package::
    package (int& argc,
             char** argv,
             int& end,
             bool erase,
             ::brep::cli::unknown_mode opt,
             ::brep::cli::unknown_mode arg)
    : package_description_ (500),
      package_changes_ (5000)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package::
    package (int start,
             int& argc,
             char** argv,
             int& end,
             bool erase,
             ::brep::cli::unknown_mode opt,
             ::brep::cli::unknown_mode arg)
    : package_description_ (500),
      package_changes_ (5000)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package::
    package (::brep::cli::scanner& s,
             ::brep::cli::unknown_mode opt,
             ::brep::cli::unknown_mode arg)
    : package_description_ (500),
      package_changes_ (5000)
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_desc_type: ::brep::cli::options
    {
      _cli_package_desc_type ()
      {
        ::brep::options::package::fill (*this);
      }
    };

    void package::
    fill (::brep::cli::options& os)
    {
      // package-description
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("500");
        ::brep::cli::option o ("package-description", a, false, dv);
        os.push_back (o);
      }

      // package-changes
      //
      {
        ::brep::cli::option_names a;
        std::string dv ("5000");
        ::brep::cli::option o ("package-changes", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& package::
    description ()
    {
      static _cli_package_desc_type _cli_package_desc_;
      return _cli_package_desc_;
    };

    typedef
    std::map<std::string, void (*) (package&, ::brep::cli::scanner&)>
    _cli_package_map;

    static _cli_package_map _cli_package_map_;

    struct _cli_package_map_init
    {
      _cli_package_map_init ()
      {
        _cli_package_map_["package-description"] = 
        &::brep::cli::thunk< package, uint16_t, &package::package_description_ >;
        _cli_package_map_["package-changes"] = 
        &::brep::cli::thunk< package, uint16_t, &package::package_changes_ >;
      }
    };

    static _cli_package_map_init _cli_package_map_init_;

    bool package::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_map::const_iterator i (_cli_package_map_.find (o));

      if (i != _cli_package_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void package::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // package_search
    //

    package_search::
    package_search ()
    {
    }

    package_search::
    package_search (int& argc,
                    char** argv,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_search::
    package_search (int start,
                    int& argc,
                    char** argv,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_search::
    package_search (int& argc,
                    char** argv,
                    int& end,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_search::
    package_search (int start,
                    int& argc,
                    char** argv,
                    int& end,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_search::
    package_search (::brep::cli::scanner& s,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_search_desc_type: ::brep::cli::options
    {
      _cli_package_search_desc_type ()
      {
        ::brep::options::package_search::fill (*this);
      }
    };

    void package_search::
    fill (::brep::cli::options& os)
    {
      // search base
      //
      ::brep::options::search::fill (os);

      // db base
      //
      ::brep::options::db::fill (os);

      // module base
      //
      ::brep::options::module::fill (os);
    }

    const ::brep::cli::options& package_search::
    description ()
    {
      static _cli_package_search_desc_type _cli_package_search_desc_;
      return _cli_package_search_desc_;
    };

    typedef
    std::map<std::string, void (*) (package_search&, ::brep::cli::scanner&)>
    _cli_package_search_map;

    static _cli_package_search_map _cli_package_search_map_;

    struct _cli_package_search_map_init
    {
      _cli_package_search_map_init ()
      {
      }
    };

    static _cli_package_search_map_init _cli_package_search_map_init_;

    bool package_search::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_search_map::const_iterator i (_cli_package_search_map_.find (o));

      if (i != _cli_package_search_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      // search base
      //
      if (::brep::options::search::_parse (o, s))
        return true;

      // db base
      //
      if (::brep::options::db::_parse (o, s))
        return true;

      // module base
      //
      if (::brep::options::module::_parse (o, s))
        return true;

      return false;
    }

    void package_search::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // package_details
    //

    package_details::
    package_details ()
    {
    }

    package_details::
    package_details (int& argc,
                     char** argv,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_details::
    package_details (int start,
                     int& argc,
                     char** argv,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_details::
    package_details (int& argc,
                     char** argv,
                     int& end,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_details::
    package_details (int start,
                     int& argc,
                     char** argv,
                     int& end,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_details::
    package_details (::brep::cli::scanner& s,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_details_desc_type: ::brep::cli::options
    {
      _cli_package_details_desc_type ()
      {
        ::brep::options::package_details::fill (*this);
      }
    };

    void package_details::
    fill (::brep::cli::options& os)
    {
      // package base
      //
      ::brep::options::package::fill (os);

      // search base
      //
      ::brep::options::search::fill (os);

      // db base
      //
      ::brep::options::db::fill (os);

      // module base
      //
      ::brep::options::module::fill (os);
    }

    const ::brep::cli::options& package_details::
    description ()
    {
      static _cli_package_details_desc_type _cli_package_details_desc_;
      return _cli_package_details_desc_;
    };

    typedef
    std::map<std::string, void (*) (package_details&, ::brep::cli::scanner&)>
    _cli_package_details_map;

    static _cli_package_details_map _cli_package_details_map_;

    struct _cli_package_details_map_init
    {
      _cli_package_details_map_init ()
      {
      }
    };

    static _cli_package_details_map_init _cli_package_details_map_init_;

    bool package_details::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_details_map::const_iterator i (_cli_package_details_map_.find (o));

      if (i != _cli_package_details_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      // package base
      //
      if (::brep::options::package::_parse (o, s))
        return true;

      // search base
      //
      if (::brep::options::search::_parse (o, s))
        return true;

      // db base
      //
      if (::brep::options::db::_parse (o, s))
        return true;

      // module base
      //
      if (::brep::options::module::_parse (o, s))
        return true;

      return false;
    }

    void package_details::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // package_version_details
    //

    package_version_details::
    package_version_details ()
    {
    }

    package_version_details::
    package_version_details (int& argc,
                             char** argv,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_version_details::
    package_version_details (int start,
                             int& argc,
                             char** argv,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_version_details::
    package_version_details (int& argc,
                             char** argv,
                             int& end,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_version_details::
    package_version_details (int start,
                             int& argc,
                             char** argv,
                             int& end,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_version_details::
    package_version_details (::brep::cli::scanner& s,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_version_details_desc_type: ::brep::cli::options
    {
      _cli_package_version_details_desc_type ()
      {
        ::brep::options::package_version_details::fill (*this);
      }
    };

    void package_version_details::
    fill (::brep::cli::options& os)
    {
      // package base
      //
      ::brep::options::package::fill (os);

      // db base
      //
      ::brep::options::db::fill (os);

      // module base
      //
      ::brep::options::module::fill (os);
    }

    const ::brep::cli::options& package_version_details::
    description ()
    {
      static _cli_package_version_details_desc_type _cli_package_version_details_desc_;
      return _cli_package_version_details_desc_;
    };

    typedef
    std::map<std::string, void (*) (package_version_details&, ::brep::cli::scanner&)>
    _cli_package_version_details_map;

    static _cli_package_version_details_map _cli_package_version_details_map_;

    struct _cli_package_version_details_map_init
    {
      _cli_package_version_details_map_init ()
      {
      }
    };

    static _cli_package_version_details_map_init _cli_package_version_details_map_init_;

    bool package_version_details::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_version_details_map::const_iterator i (_cli_package_version_details_map_.find (o));

      if (i != _cli_package_version_details_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      // package base
      //
      if (::brep::options::package::_parse (o, s))
        return true;

      // db base
      //
      if (::brep::options::db::_parse (o, s))
        return true;

      // module base
      //
      if (::brep::options::module::_parse (o, s))
        return true;

      return false;
    }

    void package_version_details::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // repository_details
    //

    repository_details::
    repository_details ()
    {
    }

    repository_details::
    repository_details (int& argc,
                        char** argv,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    repository_details::
    repository_details (int start,
                        int& argc,
                        char** argv,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    repository_details::
    repository_details (int& argc,
                        char** argv,
                        int& end,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    repository_details::
    repository_details (int start,
                        int& argc,
                        char** argv,
                        int& end,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    repository_details::
    repository_details (::brep::cli::scanner& s,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      _parse (s, opt, arg);
    }

    struct _cli_repository_details_desc_type: ::brep::cli::options
    {
      _cli_repository_details_desc_type ()
      {
        ::brep::options::repository_details::fill (*this);
      }
    };

    void repository_details::
    fill (::brep::cli::options& os)
    {
      // db base
      //
      ::brep::options::db::fill (os);

      // module base
      //
      ::brep::options::module::fill (os);
    }

    const ::brep::cli::options& repository_details::
    description ()
    {
      static _cli_repository_details_desc_type _cli_repository_details_desc_;
      return _cli_repository_details_desc_;
    };

    typedef
    std::map<std::string, void (*) (repository_details&, ::brep::cli::scanner&)>
    _cli_repository_details_map;

    static _cli_repository_details_map _cli_repository_details_map_;

    struct _cli_repository_details_map_init
    {
      _cli_repository_details_map_init ()
      {
      }
    };

    static _cli_repository_details_map_init _cli_repository_details_map_init_;

    bool repository_details::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_repository_details_map::const_iterator i (_cli_repository_details_map_.find (o));

      if (i != _cli_repository_details_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      // db base
      //
      if (::brep::options::db::_parse (o, s))
        return true;

      // module base
      //
      if (::brep::options::module::_parse (o, s))
        return true;

      return false;
    }

    void repository_details::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // repository_root
    //

    repository_root::
    repository_root ()
    {
    }

    repository_root::
    repository_root (int& argc,
                     char** argv,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    repository_root::
    repository_root (int start,
                     int& argc,
                     char** argv,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    repository_root::
    repository_root (int& argc,
                     char** argv,
                     int& end,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    repository_root::
    repository_root (int start,
                     int& argc,
                     char** argv,
                     int& end,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    repository_root::
    repository_root (::brep::cli::scanner& s,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    {
      _parse (s, opt, arg);
    }

    struct _cli_repository_root_desc_type: ::brep::cli::options
    {
      _cli_repository_root_desc_type ()
      {
        ::brep::options::repository_root::fill (*this);
      }
    };

    void repository_root::
    fill (::brep::cli::options& os)
    {
      // module base
      //
      ::brep::options::module::fill (os);
    }

    const ::brep::cli::options& repository_root::
    description ()
    {
      static _cli_repository_root_desc_type _cli_repository_root_desc_;
      return _cli_repository_root_desc_;
    };

    typedef
    std::map<std::string, void (*) (repository_root&, ::brep::cli::scanner&)>
    _cli_repository_root_map;

    static _cli_repository_root_map _cli_repository_root_map_;

    struct _cli_repository_root_map_init
    {
      _cli_repository_root_map_init ()
      {
      }
    };

    static _cli_repository_root_map_init _cli_repository_root_map_init_;

    bool repository_root::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_repository_root_map::const_iterator i (_cli_repository_root_map_.find (o));

      if (i != _cli_repository_root_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      // module base
      //
      if (::brep::options::module::_parse (o, s))
        return true;

      return false;
    }

    void repository_root::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }
  }

  namespace params
  {
    // package_search
    //

    package_search::
    package_search ()
    : page_ (),
      query_ ()
    {
    }

    package_search::
    package_search (int& argc,
                    char** argv,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ ()
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_search::
    package_search (int start,
                    int& argc,
                    char** argv,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ ()
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_search::
    package_search (int& argc,
                    char** argv,
                    int& end,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ ()
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_search::
    package_search (int start,
                    int& argc,
                    char** argv,
                    int& end,
                    bool erase,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ ()
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_search::
    package_search (::brep::cli::scanner& s,
                    ::brep::cli::unknown_mode opt,
                    ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ ()
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_search_desc_type: ::brep::cli::options
    {
      _cli_package_search_desc_type ()
      {
        ::brep::params::package_search::fill (*this);
      }
    };

    void package_search::
    fill (::brep::cli::options& os)
    {
      // page
      //
      {
        ::brep::cli::option_names a;
        a.push_back ("p");
        std::string dv;
        ::brep::cli::option o ("page", a, false, dv);
        os.push_back (o);
      }

      // query
      //
      {
        ::brep::cli::option_names a;
        a.push_back ("q");
        std::string dv;
        ::brep::cli::option o ("query", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& package_search::
    description ()
    {
      static _cli_package_search_desc_type _cli_package_search_desc_;
      return _cli_package_search_desc_;
    };

    typedef
    std::map<std::string, void (*) (package_search&, ::brep::cli::scanner&)>
    _cli_package_search_map;

    static _cli_package_search_map _cli_package_search_map_;

    struct _cli_package_search_map_init
    {
      _cli_package_search_map_init ()
      {
        _cli_package_search_map_["page"] = 
        &::brep::cli::thunk< package_search, uint16_t, &package_search::page_ >;
        _cli_package_search_map_["p"] = 
        &::brep::cli::thunk< package_search, uint16_t, &package_search::page_ >;
        _cli_package_search_map_["query"] = 
        &::brep::cli::thunk< package_search, string, &package_search::query_ >;
        _cli_package_search_map_["q"] = 
        &::brep::cli::thunk< package_search, string, &package_search::query_ >;
      }
    };

    static _cli_package_search_map_init _cli_package_search_map_init_;

    bool package_search::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_search_map::const_iterator i (_cli_package_search_map_.find (o));

      if (i != _cli_package_search_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void package_search::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // package_details
    //

    package_details::
    package_details ()
    : page_ (),
      query_ (),
      form_ (page_form::brief)
    {
    }

    package_details::
    package_details (int& argc,
                     char** argv,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ (),
      form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_details::
    package_details (int start,
                     int& argc,
                     char** argv,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ (),
      form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_details::
    package_details (int& argc,
                     char** argv,
                     int& end,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ (),
      form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_details::
    package_details (int start,
                     int& argc,
                     char** argv,
                     int& end,
                     bool erase,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ (),
      form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_details::
    package_details (::brep::cli::scanner& s,
                     ::brep::cli::unknown_mode opt,
                     ::brep::cli::unknown_mode arg)
    : page_ (),
      query_ (),
      form_ (page_form::brief)
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_details_desc_type: ::brep::cli::options
    {
      _cli_package_details_desc_type ()
      {
        ::brep::params::package_details::fill (*this);
      }
    };

    void package_details::
    fill (::brep::cli::options& os)
    {
      // page
      //
      {
        ::brep::cli::option_names a;
        a.push_back ("p");
        std::string dv;
        ::brep::cli::option o ("page", a, false, dv);
        os.push_back (o);
      }

      // query
      //
      {
        ::brep::cli::option_names a;
        a.push_back ("q");
        std::string dv;
        ::brep::cli::option o ("query", a, false, dv);
        os.push_back (o);
      }

      // form
      //
      {
        ::brep::cli::option_names a;
        a.push_back ("f");
        std::string dv;
        ::brep::cli::option o ("form", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& package_details::
    description ()
    {
      static _cli_package_details_desc_type _cli_package_details_desc_;
      return _cli_package_details_desc_;
    };

    typedef
    std::map<std::string, void (*) (package_details&, ::brep::cli::scanner&)>
    _cli_package_details_map;

    static _cli_package_details_map _cli_package_details_map_;

    struct _cli_package_details_map_init
    {
      _cli_package_details_map_init ()
      {
        _cli_package_details_map_["page"] = 
        &::brep::cli::thunk< package_details, uint16_t, &package_details::page_ >;
        _cli_package_details_map_["p"] = 
        &::brep::cli::thunk< package_details, uint16_t, &package_details::page_ >;
        _cli_package_details_map_["query"] = 
        &::brep::cli::thunk< package_details, string, &package_details::query_ >;
        _cli_package_details_map_["q"] = 
        &::brep::cli::thunk< package_details, string, &package_details::query_ >;
        _cli_package_details_map_["form"] = 
        &::brep::cli::thunk< package_details, page_form, &package_details::form_ >;
        _cli_package_details_map_["f"] = 
        &::brep::cli::thunk< package_details, page_form, &package_details::form_ >;
      }
    };

    static _cli_package_details_map_init _cli_package_details_map_init_;

    bool package_details::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_details_map::const_iterator i (_cli_package_details_map_.find (o));

      if (i != _cli_package_details_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void package_details::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // package_version_details
    //

    package_version_details::
    package_version_details ()
    : form_ (page_form::brief)
    {
    }

    package_version_details::
    package_version_details (int& argc,
                             char** argv,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    : form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_version_details::
    package_version_details (int start,
                             int& argc,
                             char** argv,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    : form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    package_version_details::
    package_version_details (int& argc,
                             char** argv,
                             int& end,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    : form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_version_details::
    package_version_details (int start,
                             int& argc,
                             char** argv,
                             int& end,
                             bool erase,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    : form_ (page_form::brief)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    package_version_details::
    package_version_details (::brep::cli::scanner& s,
                             ::brep::cli::unknown_mode opt,
                             ::brep::cli::unknown_mode arg)
    : form_ (page_form::brief)
    {
      _parse (s, opt, arg);
    }

    struct _cli_package_version_details_desc_type: ::brep::cli::options
    {
      _cli_package_version_details_desc_type ()
      {
        ::brep::params::package_version_details::fill (*this);
      }
    };

    void package_version_details::
    fill (::brep::cli::options& os)
    {
      // form
      //
      {
        ::brep::cli::option_names a;
        a.push_back ("f");
        std::string dv;
        ::brep::cli::option o ("form", a, false, dv);
        os.push_back (o);
      }
    }

    const ::brep::cli::options& package_version_details::
    description ()
    {
      static _cli_package_version_details_desc_type _cli_package_version_details_desc_;
      return _cli_package_version_details_desc_;
    };

    typedef
    std::map<std::string, void (*) (package_version_details&, ::brep::cli::scanner&)>
    _cli_package_version_details_map;

    static _cli_package_version_details_map _cli_package_version_details_map_;

    struct _cli_package_version_details_map_init
    {
      _cli_package_version_details_map_init ()
      {
        _cli_package_version_details_map_["form"] = 
        &::brep::cli::thunk< package_version_details, page_form, &package_version_details::form_ >;
        _cli_package_version_details_map_["f"] = 
        &::brep::cli::thunk< package_version_details, page_form, &package_version_details::form_ >;
      }
    };

    static _cli_package_version_details_map_init _cli_package_version_details_map_init_;

    bool package_version_details::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_package_version_details_map::const_iterator i (_cli_package_version_details_map_.find (o));

      if (i != _cli_package_version_details_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void package_version_details::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }

    // repository_details
    //

    repository_details::
    repository_details ()
    {
    }

    repository_details::
    repository_details (int& argc,
                        char** argv,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
    }

    repository_details::
    repository_details (int start,
                        int& argc,
                        char** argv,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
    }

    repository_details::
    repository_details (int& argc,
                        char** argv,
                        int& end,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    repository_details::
    repository_details (int start,
                        int& argc,
                        char** argv,
                        int& end,
                        bool erase,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      ::brep::cli::argv_scanner s (start, argc, argv, erase);
      _parse (s, opt, arg);
      end = s.end ();
    }

    repository_details::
    repository_details (::brep::cli::scanner& s,
                        ::brep::cli::unknown_mode opt,
                        ::brep::cli::unknown_mode arg)
    {
      _parse (s, opt, arg);
    }

    struct _cli_repository_details_desc_type: ::brep::cli::options
    {
      _cli_repository_details_desc_type ()
      {
        ::brep::params::repository_details::fill (*this);
      }
    };

    void repository_details::
    fill (::brep::cli::options&)
    {
    }

    const ::brep::cli::options& repository_details::
    description ()
    {
      static _cli_repository_details_desc_type _cli_repository_details_desc_;
      return _cli_repository_details_desc_;
    };

    typedef
    std::map<std::string, void (*) (repository_details&, ::brep::cli::scanner&)>
    _cli_repository_details_map;

    static _cli_repository_details_map _cli_repository_details_map_;

    struct _cli_repository_details_map_init
    {
      _cli_repository_details_map_init ()
      {
      }
    };

    static _cli_repository_details_map_init _cli_repository_details_map_init_;

    bool repository_details::
    _parse (const char* o, ::brep::cli::scanner& s)
    {
      _cli_repository_details_map::const_iterator i (_cli_repository_details_map_.find (o));

      if (i != _cli_repository_details_map_.end ())
      {
        (*(i->second)) (*this, s);
        return true;
      }

      return false;
    }

    void repository_details::
    _parse (::brep::cli::scanner& s,
            ::brep::cli::unknown_mode,
            ::brep::cli::unknown_mode arg_mode)
    {
      bool opt = true;

      while (s.more ())
      {
        const char* o = s.peek ();

        if (std::strcmp (o, "--") == 0)
        {
          s.skip ();
          opt = false;
          continue;
        }

        if (opt && _parse (o, s));
        else
        {
          switch (arg_mode)
          {
            case ::brep::cli::unknown_mode::skip:
            {
              s.skip ();
              continue;
            }
            case ::brep::cli::unknown_mode::stop:
            {
              break;
            }
            case ::brep::cli::unknown_mode::fail:
            {
              throw ::brep::cli::unknown_argument (o);
            }
          }

          break;
        }
      }
    }
  }
}

// Begin epilogue.
//
//
// End epilogue.

