/* This file was generated by ODB, object-relational mapping (ORM)
 * compiler for C++.
 */

DROP TABLE IF EXISTS "package_other_repositories" CASCADE;

DROP TABLE IF EXISTS "package_requirement_alternatives" CASCADE;

DROP TABLE IF EXISTS "package_requirements" CASCADE;

DROP TABLE IF EXISTS "package_dependency_alternatives" CASCADE;

DROP TABLE IF EXISTS "package_dependencies" CASCADE;

DROP TABLE IF EXISTS "package_tags" CASCADE;

DROP TABLE IF EXISTS "package_licenses" CASCADE;

DROP TABLE IF EXISTS "package_license_alternatives" CASCADE;

DROP TABLE IF EXISTS "package" CASCADE;

DROP TABLE IF EXISTS "repository_prerequisites" CASCADE;

DROP TABLE IF EXISTS "repository_complements" CASCADE;

DROP TABLE IF EXISTS "repository" CASCADE;

DROP TABLE IF EXISTS "schema_version";

CREATE TABLE "repository" (
  "name" TEXT NOT NULL PRIMARY KEY,
  "location" TEXT NOT NULL,
  "display_name" TEXT NOT NULL,
  "priority" INTEGER NOT NULL,
  "url" TEXT NULL,
  "email" TEXT NULL,
  "summary" TEXT NULL,
  "description" TEXT NULL,
  "local_path" TEXT NOT NULL,
  "packages_timestamp" BIGINT NOT NULL,
  "repositories_timestamp" BIGINT NOT NULL,
  "internal" BOOLEAN NOT NULL);

CREATE TABLE "repository_complements" (
  "repository" TEXT NOT NULL,
  "index" BIGINT NOT NULL,
  "complement" TEXT NOT NULL,
  CONSTRAINT "repository_fk"
    FOREIGN KEY ("repository")
    REFERENCES "repository" ("name")
    ON DELETE CASCADE,
  CONSTRAINT "complement_fk"
    FOREIGN KEY ("complement")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "repository_complements_repository_i"
  ON "repository_complements" ("repository");

CREATE INDEX "repository_complements_index_i"
  ON "repository_complements" ("index");

CREATE TABLE "repository_prerequisites" (
  "repository" TEXT NOT NULL,
  "index" BIGINT NOT NULL,
  "prerequisite" TEXT NOT NULL,
  CONSTRAINT "repository_fk"
    FOREIGN KEY ("repository")
    REFERENCES "repository" ("name")
    ON DELETE CASCADE,
  CONSTRAINT "prerequisite_fk"
    FOREIGN KEY ("prerequisite")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "repository_prerequisites_repository_i"
  ON "repository_prerequisites" ("repository");

CREATE INDEX "repository_prerequisites_index_i"
  ON "repository_prerequisites" ("index");

CREATE TABLE "package" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "version_upstream" TEXT NOT NULL,
  "version_release" TEXT NULL,
  "priority" INTEGER NOT NULL,
  "priority_comment" TEXT NOT NULL,
  "summary" TEXT NOT NULL,
  "description" TEXT NULL,
  "changes" TEXT NOT NULL,
  "url" TEXT NOT NULL,
  "url_comment" TEXT NOT NULL,
  "package_url" TEXT NULL,
  "package_url_comment" TEXT NULL,
  "email" TEXT NOT NULL,
  "email_comment" TEXT NOT NULL,
  "package_email" TEXT NULL,
  "package_email_comment" TEXT NULL,
  "internal_repository" TEXT NULL,
  "location" TEXT NULL,
  "search_index" tsvector NULL,
  PRIMARY KEY ("name",
               "version_epoch",
               "version_canonical_upstream",
               "version_canonical_release",
               "version_revision"),
  CONSTRAINT "internal_repository_fk"
    FOREIGN KEY ("internal_repository")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "package_search_index_i"
  ON "package" USING GIN ("search_index");

CREATE TABLE "package_license_alternatives" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "comment" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_license_alternatives_object_id_i"
  ON "package_license_alternatives" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_license_alternatives_index_i"
  ON "package_license_alternatives" ("index");

CREATE TABLE "package_licenses" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "alternative_index" BIGINT NOT NULL,
  "index" BIGINT NOT NULL,
  "license" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_licenses_object_id_i"
  ON "package_licenses" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE TABLE "package_tags" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "tag" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_tags_object_id_i"
  ON "package_tags" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_tags_index_i"
  ON "package_tags" ("index");

CREATE TABLE "package_dependencies" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "conditional" BOOLEAN NOT NULL,
  "comment" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_dependencies_object_id_i"
  ON "package_dependencies" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_dependencies_index_i"
  ON "package_dependencies" ("index");

CREATE TABLE "package_dependency_alternatives" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "dependency_index" BIGINT NOT NULL,
  "index" BIGINT NOT NULL,
  "dep_name" TEXT NOT NULL,
  "dep_version_epoch" INTEGER NOT NULL,
  "dep_version_canonical_upstream" TEXT NOT NULL,
  "dep_version_canonical_release" TEXT NOT NULL COLLATE "C",
  "dep_version_revision" INTEGER NOT NULL,
  "dep_min_version_epoch" INTEGER NULL,
  "dep_min_version_canonical_upstream" TEXT NULL,
  "dep_min_version_canonical_release" TEXT NULL,
  "dep_min_version_revision" INTEGER NULL,
  "dep_min_version_upstream" TEXT NULL,
  "dep_min_version_release" TEXT NULL,
  "dep_max_version_epoch" INTEGER NULL,
  "dep_max_version_canonical_upstream" TEXT NULL,
  "dep_max_version_canonical_release" TEXT NULL,
  "dep_max_version_revision" INTEGER NULL,
  "dep_max_version_upstream" TEXT NULL,
  "dep_max_version_release" TEXT NULL,
  "dep_min_open" BOOLEAN NULL,
  "dep_max_open" BOOLEAN NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE,
  CONSTRAINT "dep_package_fk"
    FOREIGN KEY ("dep_name",
                 "dep_version_epoch",
                 "dep_version_canonical_upstream",
                 "dep_version_canonical_release",
                 "dep_version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    INITIALLY DEFERRED);

CREATE INDEX "package_dependency_alternatives_object_id_i"
  ON "package_dependency_alternatives" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE TABLE "package_requirements" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "conditional" BOOLEAN NOT NULL,
  "comment" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_requirements_object_id_i"
  ON "package_requirements" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_requirements_index_i"
  ON "package_requirements" ("index");

CREATE TABLE "package_requirement_alternatives" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "requirement_index" BIGINT NOT NULL,
  "index" BIGINT NOT NULL,
  "id" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE);

CREATE INDEX "package_requirement_alternatives_object_id_i"
  ON "package_requirement_alternatives" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE TABLE "package_other_repositories" (
  "name" TEXT NOT NULL,
  "version_epoch" INTEGER NOT NULL,
  "version_canonical_upstream" TEXT NOT NULL,
  "version_canonical_release" TEXT NOT NULL COLLATE "C",
  "version_revision" INTEGER NOT NULL,
  "index" BIGINT NOT NULL,
  "repository" TEXT NOT NULL,
  CONSTRAINT "object_id_fk"
    FOREIGN KEY ("name",
                 "version_epoch",
                 "version_canonical_upstream",
                 "version_canonical_release",
                 "version_revision")
    REFERENCES "package" ("name",
                          "version_epoch",
                          "version_canonical_upstream",
                          "version_canonical_release",
                          "version_revision")
    ON DELETE CASCADE,
  CONSTRAINT "repository_fk"
    FOREIGN KEY ("repository")
    REFERENCES "repository" ("name")
    INITIALLY DEFERRED);

CREATE INDEX "package_other_repositories_object_id_i"
  ON "package_other_repositories" (
    "name",
    "version_epoch",
    "version_canonical_upstream",
    "version_canonical_release",
    "version_revision");

CREATE INDEX "package_other_repositories_index_i"
  ON "package_other_repositories" ("index");

CREATE TABLE "schema_version" (
  "name" TEXT NOT NULL PRIMARY KEY,
  "version" BIGINT NOT NULL,
  "migration" BOOLEAN NOT NULL);

INSERT INTO "schema_version" (
  "name", "version", "migration")
  VALUES ('', 1, FALSE);

